story1/urls.py
from django.urls import path

from . import views

app_name = 'story1'

urlpatterns = [
    path('', views.index, name='index'),
]

story3/urls.py
from django.urls import path

from . import views

app_name = 'story3'

urlpatterns = [
    path('', views.index, name='index'),
    path('extras/', views.extras, name='extras')
]

story5/urls.py
from django.urls import path
from . import views
from .views import MatkulView, MatkulDetailView, DeleteMatkulView

app_name = 'story5'

urlpatterns = [
    path('', views.index, name='index'),
    path('listmatkul/', MatkulView.as_view(), name='list-matkul'),
    path('matkul/<int:pk>/', MatkulDetailView.as_view(), name='matkul-details'),
    path('matkul/<int:pk>/delete', DeleteMatkulView.as_view(), name='delete-matkul'),
]

story9/urls.py
from django.urls import path
from . import views

app_name = 'story9'

urlpatterns = [
    path('login/', views.login_request, name='login'),
    path('signup/', views.signup_request, name='signup'),
    path('logout/', views.logout_request, name='logout')
]

storyppw/urls.py
from django.contrib import admin
from django.urls import path, include

urlpatterns = [
    path('admin/', admin.site.urls),
    path('', include('story3.urls')),
    path('story3/', include('story3.urls')),
    path('story1/', include('story1.urls')),
    path('story5/', include('story5.urls')),
    path('story6/', include('story6.urls')),
    path('story7/', include('story7.urls')),
    path('story8/', include('story8.urls')),
    path('story9/', include('story9.urls'))
]

story5/models.py
from django.db import models
from django.urls import reverse

# Create your models here.
class MataKuliah(models.Model):
    nama_matkul = models.CharField(max_length=255)
    dosen_pengajar = models.CharField(max_length=255)
    jumlah_sks = models.CharField(max_length=2)
    deskripsi = models.TextField(blank=True, null=True)
    semester = models.CharField(max_length=20)
    ruang_kelas = models.CharField(max_length=10)

    # def get_absolute_url(self):
    #     return reverse('story5:matkul-details', args=(str(self.id)))

story5/forms.py
from django import forms
from .models import MataKuliah

class MatkulForm(forms.ModelForm):
    class Meta:
        model = MataKuliah
        fields = (
            'nama_matkul',
            'dosen_pengajar',
            'jumlah_sks',
            'deskripsi',
            'semester',
            'ruang_kelas'
        )
        widgets = {
            'nama_matkul': forms.TextInput(attrs={'class': 'form-control'}),
            'dosen_pengajar': forms.TextInput(attrs={'class': 'form-control'}),
            'jumlah_sks': forms.TextInput(attrs={'class': 'form-control'}),
            'deskripsi': forms.Textarea(attrs={'class': 'form-control'}),
            'semester': forms.TextInput(attrs={'class': 'form-control'}),
            'ruang_kelas': forms.TextInput(attrs={'class': 'form-control'}),
        }
        

story5/views.py
from django.contrib.auth.decorators import login_required
from django.utils.decorators import method_decorator
from django.shortcuts import render
from django.views.generic import ListView, DetailView, DeleteView
from .models import MataKuliah
from .forms import MatkulForm
from django.urls import reverse_lazy

@login_required
def index(request):

    form = MatkulForm(request.POST or None)
    if form.is_valid():
        form.save()
        form = MatkulForm()
    
    context = {'form' : form}
    return render(request, 'story5/index.html', context)

# class AddMatkulView(CreateView):
#     model = MataKuliah
#     template_name = 'story5/index.html'
#     fields = '__all__'

@method_decorator(login_required(login_url='login'), name='dispatch')
class MatkulView(ListView):
    model = MataKuliah
    template_name = 'story5/list_matkul.html'

@method_decorator(login_required(login_url='login'), name='dispatch')
class MatkulDetailView(DetailView):
    model = MataKuliah
    template_name = 'story5/matkul_details.html'

@method_decorator(login_required(login_url='login'), name='dispatch')
class DeleteMatkulView(DeleteView):
    model = MataKuliah
    template_name = 'story5/delete_matkul.html'
    success_url = reverse_lazy('story5:list-matkul')

story5/templates/story5/delete_matkul.html
{% extends 'base.html' %}
{% load static %}

{% block meta %}
<title>Story 5</title>
<link rel='stylesheet' href='{% static "story3/css/style.css"%}'>
{% endblock meta %}

{% block navbarmenus %}
<li class="nav-item">
  <a class="nav-link" href="{% url 'story3:index' %}">Back to Story 3</a>
</li>
{% if user.is_authenticated %}
<li class="nav-item">
    <a class="nav-link" href="{% url 'story9:logout' %}">Logout</a>
</li>
{% endif %}
{% endblock navbarmenus %}

{% block content %}
<div class="main">
    <div class="section">
        <div class="story5-column">
            <h1 class="story5-delete-message">Hapus <span style="color: #C60719;">{{ matakuliah.nama_matkul }}</span>?</h1>
            <form method="POST">
                {% csrf_token %}
                <button class="story5 btn hapus-matkul">Hapus</button><br>
            </form>
            <a class="story5 btn-a hapus-matkul" href="{% url 'story5:matkul-details' matakuliah.pk %}">Batal</a>
        </div>
    </div>
</div>
{% endblock content %}

story5/templates/story5/index.html
{% extends 'base.html' %}
{% load static %}

{% block meta %}
<title>Story 5</title>
<link rel='stylesheet' href='{% static "story3/css/style.css"%}'>
{% endblock meta %}

{% block navbarmenus %}
<li class="nav-item">
  <a class="nav-link" href="{% url 'story5:index' %}">Tambah Matkul</a>
</li>
<li class="nav-item">
  <a class="nav-link" href="{% url 'story5:list-matkul' %}">List Matkul</a>
</li>
<li class="nav-item">
  <a class="nav-link" href="/">Back to Story 3</a>
</li>
{% if user.is_authenticated %}
<li class="nav-item">
    <a class="nav-link" href="{% url 'story9:logout' %}">Logout</a>
</li>
{% endif %}
{% endblock navbarmenus %}

{% block content %}
  <div class="main">
    <div class="section">
      <h1 class="section-title-h1">Tambah Mata Kuliah</h1>
      <div class="underline story5-tambahmatkul"></div>
      <div class="form-group">
        <form action="" method="POST">
          {% csrf_token %}
          <div class="field-wrapper">
            <label for="{{ form.nama_matkul.id_for_label }}" class="label">Nama Matkul:</label>
            {{ form.nama_matkul }}
          </div>
          <div class="field-wrapper">
            <label for="{{ form.dosen_pengajar.id_for_label }}" class="label">Dosen Pengajar:</label>
            {{ form.dosen_pengajar }}
          </div>
          <div class="field-wrapper">
            <label for="{{ form.jumlah_sks.id_for_label }}" class="label">Jumlah SKS:</label>
            {{ form.jumlah_sks }}
          </div>
          <div class="field-wrapper">
            <label for="{{ form.deskripsi.id_for_label }}" class="label">Deskripsi:</label>
            {{ form.deskripsi }}
          </div>
          <div class="field-wrapper">
            <label for="{{ form.semester.id_for_label }}" class="label">Semester:</label>
            {{ form.semester }}
          </div>
          <div class="field-wrapper">
            <label for="{{ form.ruang_kelas.id_for_label }}" class="label">Ruang Kelas:</label>
            {{ form.ruang_kelas }}
          </div>
          <button class="story5 btn">Submit</button>
        </form>
      </div>
    </div>
  </div>
{% endblock content %}

story5/templates/story5/list_matkul.html
{% extends 'base.html' %}
{% load static %}

{% block meta %}
<title>Story 5</title>
<link rel='stylesheet' href='{% static "story3/css/style.css"%}'>
{% endblock meta %}

{% block navbarmenus %}
<li class="nav-item">
  <a class="nav-link" href="{% url 'story5:index' %}">Tambah Matkul</a>
</li>
<li class="nav-item">
  <a class="nav-link" href="{% url 'story5:list-matkul' %}">List Matkul</a>
</li>
<li class="nav-item">
  <a class="nav-link" href="{% url 'story3:index' %}">Back to Story 3</a>
</li>
{% if user.is_authenticated %}
<li class="nav-item">
    <a class="nav-link" href="{% url 'story9:logout' %}">Logout</a>
</li>
{% endif %}
{% endblock navbarmenus %}

{% block content %}
  <div class="main">
    <div class="section">
      <h1 class="section-title-h1">List Mata Kuliah</h1>
      <div class="underline story5-listmatkul"></div>
      {% for matkul in object_list %}
      <a class="story5-namamatkul-btn" href="{% url 'story5:matkul-details' matkul.pk %}">
        <p class="story5-namamatkul">{{ matkul.nama_matkul }}</p>
      </a>
      {% endfor %}
      </div>
    </div>
  </div>
{% endblock content %}

story5/templates/story5/matkul_details.html
{% extends 'base.html' %}
{% load static %}

{% block meta %}
<title>Story 5</title>
<link rel='stylesheet' href='{% static "story3/css/style.css"%}'>
{% endblock meta %}

{% block navbarmenus %}
<li class="nav-item">
  <a class="nav-link" href="{% url 'story3:index' %}">Back to Story 3</a>
</li>
{% if user.is_authenticated %}
<li class="nav-item">
    <a class="nav-link" href="{% url 'story9:logout' %}">Logout</a>
</li>
{% endif %}
{% endblock navbarmenus %}

{% block content %}
<div class="main">
    <div class="section">
        <h1 class="nama-matkul-h1">{{ matakuliah.nama_matkul }}</h1>
        <p class="story5-matkul-detail">{{ matakuliah.semester }} <span>|</span> {{ matakuliah.jumlah_sks }} SKS | {{ matakuliah.ruang_kelas }}</p>
        <p class="story5-matkul-detail" style="margin-bottom: 1rem;">Pengajar: {{ matakuliah.dosen_pengajar }}</p>
        <p class="story5-matkul-desc">{{ matakuliah.deskripsi }}</p>
        <a class="story5 btn-a" href="{% url 'story5:delete-matkul' matakuliah.pk %}">Hapus</a>
        <a class="story5 btn-a" href="{% url 'story5:list-matkul' %}">Kembali</a>
    </div>
</div>
{% endblock content %}